#!/bin/sh -e
# Copyright (C)2014..2020 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: testnn.sh,v 1.5 2020/01/09 16:25:43 babolo Exp $

thislib="./lib/librecobe.so.${1}"

tst1() {
    echo "./recobe $1 | diff -q /dev/stdin $2"
    env LD_PRELOAD="${thislib}" ./recobe $1 | diff -q /dev/stdin $2
}

tst2() {
    echo "./recobe $1 | ./recobe $2 | diff -q /dev/stdin $3"
    env LD_PRELOAD="${thislib}" ./recobe $1 | ./recobe $2 | diff -q /dev/stdin $3
}

tst1 '-cwk tools/utst.w' tools/utst.k
tst1 '-cak tools/utst.a' tools/utst.k
tst1 '-cik tools/utst.i' tools/utst.k
tst1 '-cmk tools/utst.m' tools/utst.k
tst1 '-czk tools/utst.z' tools/utst.k
tst1 '-cKk tools/utst.K' tools/utst.k
tst2 '-ckK tools/utst.k'    -ckK tools/utst.k
tst2 '-ckK tools/utst.k'    -cKk tools/utst.k
tst2 '-cwk tools/ztb'       -ckw tools/ztb
tst2 '-cwa tools/ztb'       -caw tools/ztb
tst2 '-cwi tools/ztb'       -ciw tools/ztb
tst2 '-cwm tools/ztb'       -cmw tools/ztb
tst2 '-cwz tools/ztb'       -czw tools/ztb
tst2 '-ku2 tools/utst.html' -k2k tools/utst.k
tst2 '-ku3 tools/utst.html' -k3k tools/utst.k
tst2 '-ku4 tools/utst.html' -k4k tools/utst.k
tst2 '-ku5 tools/utst.html' -k5k tools/utst.k
tst2 '-ku6 tools/utst.html' -k6k tools/utst.k
tst2 '-ku7 tools/utst.html' -k7k tools/utst.k
tst2 '-ku8 tools/utst.html' -k8k tools/utst.k
tst2 '-ku9 tools/utst.html' -k9k tools/utst.k
tst1 '-ku2 -k2k tools/utst.html' tools/utst.k
tst1 '-ku3 -k3k tools/utst.html' tools/utst.k
tst1 '-ku4 -k4k tools/utst.html' tools/utst.k
tst1 '-ku5 -k5k tools/utst.html' tools/utst.k
tst1 '-ku6 -k6k tools/utst.html' tools/utst.k
tst1 '-ku7 -k7k tools/utst.html' tools/utst.k
tst1 '-ku8 -k8k tools/utst.html' tools/utst.k
tst1 '-ku9 -k9k tools/utst.html' tools/utst.k
tst1 '-ku2 -k2k -ckw tools/utst.html' tools/utst.w
tst1 '-ku2 -k21 -k1k tools/utst.html' tools/utst.k
tst1 '-kk1 -k1u -ku2 -k2k tools/utst.k' tools/utst.k
tst1 '-ckZ tools/utst.k' tools/utst.Z
tst1 '-cky tools/utst.k' tools/utst.y
tst1 '-ckY tools/utst.k' tools/utst.Y
tst1 '-M= -kQT -hn -ku3 -k3k tools/qtst.f' tools/qtst.o
tst1 '-M= -kQT -h -ku3 -k3k tools/qtst.f' tools/qtst.n
tst1 '-M= -kQT -n -ku3 -k3k tools/qtst.f' tools/qtst.h
